//+------------------------------------------------------------------+
//|                                SoftFractalsStrategyModel_1_1.mq4 |
//|                                                    .. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " .."
#property indicator_chart_window
#property indicator_buffers 4
//---- buffers
double Buffer1[], Buffer2[], Buffer3[], Buffer4[];
//---- parameters
// Hight Frequency: 
#property indicator_color1 Red  //   
#property indicator_color2 Green//   
#property indicator_width1 1    //   
#property indicator_width2 1    //   
extern bool StrongLeftHF=false, //   
            StrongRightHF=false,//   
            RepeatHF=true,      //  / 
            ByCloseHF=false,    //    
            SignalsHF=false;    //  ,   
bool NotFirstStartHF, Ban1HF, Ban2HF;
extern int BarsBeforeHF=3,      //    
           BarsAfterHF=1,       //    
           ArrowHF=163;         //   /
// Low Frequency: 
#property indicator_color3 Yellow//   
#property indicator_color4 Blue //   
#property indicator_width3 2    //   
#property indicator_width4 2    //   
extern bool StrongLeftLF=false, //   
            StrongRightLF=false,//   
            RepeatLF=true,      //  / 
            ByCloseLF=false,    //    
            SignalsLF=false;    //  ,   
bool NotFirstStartLF, Ban1LF, Ban2LF;
extern int BarsBeforeLF=10,     //    
           BarsAfterLF=2,       //    
           WidthLF=1,           //  
           ArrowLF=163;         //   /
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, ArrowHF);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, ArrowHF);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, 0.0);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, ArrowLF);
   SetIndexBuffer(2, Buffer3);
   SetIndexEmptyValue(2, 0.0);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, ArrowLF);
   SetIndexBuffer(3, Buffer4);
   SetIndexEmptyValue(3, 0.0);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("SFSM");
   if( SignalsHF )
     {
      SetIndexLabel(0, "Sell_HF");
      SetIndexLabel(1, "Buy_HF");
     }
   else
     {
      SetIndexLabel(0, "High_HF");
      SetIndexLabel(1, "Low_HF");
     }
   if( SignalsLF )
     {
      SetIndexLabel(2, "Sell_LF");
      SetIndexLabel(3, "Buy_LF");
     }
   else
     {
      SetIndexLabel(2, "High_LF");
      SetIndexLabel(3, "Low_LF");
     }
//      : 
   NotFirstStartHF=false;
   Ban1HF=false;
   Ban2HF=false;
   if( BarsBeforeHF<1 ) BarsBeforeHF=1;
   if( BarsAfterHF<1 ) BarsAfterHF=1;
   NotFirstStartLF=false;
   Ban1LF=false;
   Ban2LF=false;
   if( BarsBeforeLF<BarsBeforeHF ) BarsBeforeLF=BarsBeforeHF;
   if( BarsAfterLF<BarsAfterHF ) BarsAfterLF=BarsAfterHF;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if( !NewBar() ) return(0);
   double R, C[];
   int dim, i, j, k=0, D, BarsBefore, BarsAfter;
   bool ByClose, StrongLeft, StrongRight, Repeat, Signals, NotFirstStart, Ban1, Ban2;
   while( k<2 )
     {
      if( k==0 )
        {
         StrongLeft=StrongLeftHF;
         StrongRight=StrongRightHF;
         Repeat=RepeatHF;
         NotFirstStart=NotFirstStartHF;
         Ban1=Ban1HF;
         Ban2=Ban2HF;
         BarsBefore=BarsBeforeHF;
         BarsAfter=BarsAfterHF;
         Signals=SignalsHF;
         ByClose=ByCloseHF;
        }
      else
        {
         StrongLeft=StrongLeftLF;
         StrongRight=StrongRightLF;
         Repeat=RepeatLF;
         NotFirstStart=NotFirstStartLF;
         Ban1=Ban1LF;
         Ban2=Ban2LF;
         BarsBefore=BarsBeforeLF;
         BarsAfter=BarsAfterLF;
         Signals=SignalsLF;
         ByClose=ByCloseLF;
        }
      dim=ArrayResize(C, BarsBefore+1+BarsAfter);
      if( NotFirstStart ) i=BarsAfter+1; else i=Bars-BarsBefore-1;
//----  
      while( i > BarsAfter )
        {
         j=0;
         if( ByClose )
           {
            while ( j < dim ) { C[j]=Close[j+i-BarsAfter]; j++; }
            if( MathAbs(C[BarsAfter+1]-C[BarsAfter]) < Point
             && MathAbs(C[BarsAfter-1]-C[BarsAfter]) < Point )
              { i--; continue; }                      //  
            if( C[BarsAfter+1] > C[BarsAfter] )
               if( C[BarsAfter] <= C[BarsAfter-1] )
                 { D=-1; R=C[BarsAfter]; }            //  
               else { i--; continue; }                //  
            else
               if( C[BarsAfter] >= C[BarsAfter-1] )
                 { D=1; R=C[BarsAfter]; }             //  
               else { i--; continue; }                //  
            j=1;
            while ( j < dim )
              {
               if( D > 0 )                            //  ?
               if( ( j < BarsAfter && C[j-1] > C[j] && StrongRight )
                || ( j < BarsAfter && C[j-1] > R && !StrongRight )
                || ( j > BarsAfter && C[j] >= C[j-1] && StrongLeft )
                || ( j > BarsAfter && C[j] >= R && !StrongLeft ) )
                 { D=0; break; }                    //  
               if( D < 0 )                            //  ?
               if( ( j < BarsAfter && C[j-1] < C[j] && StrongRight )
                || ( j < BarsAfter && C[j-1] < R && !StrongRight )
                || ( j > BarsAfter && C[j] <= C[j-1] && StrongLeft )
                || ( j > BarsAfter && C[j] <= R && !StrongLeft ) )
                 { D=0; break; }                    //  
               j++;
              }
            if( D == 0 ) { i--; continue; }           //  
            if( Signals )
              {
               j=i-BarsAfter-1;                       //  
               R=Open[j];                             //  
              }
            else j=i;                                 //  
            //         :
            if( D>0 && !Ban1 )
              {
               if( k==0 ) Buffer1[j]=R; else Buffer3[j]=R;
               if( !Repeat ) { Ban1=true; Ban2=false; }
              }
            else if( D<0 && !Ban2 )
              {
               if( k==0 ) Buffer2[j]=R; else Buffer4[j]=R;
               if( !Repeat ) { Ban1=false; Ban2=true; }
              }
           }
         else
           {
            R=0;
            while ( j < dim ) { C[j]=High[j+i-BarsAfter]; j++; }
            if( C[BarsAfter+1] < C[BarsAfter] && C[BarsAfter] >= C[BarsAfter-1] )
              {
               R=C[BarsAfter];                        //  
               j=1;
               while ( j < dim )
                 {
                  if( ( j < BarsAfter && C[j-1] > C[j] && StrongRight )
                   || ( j < BarsAfter && C[j-1] > R && !StrongRight )
                   || ( j > BarsAfter && C[j] >= C[j-1] && StrongLeft )
                   || ( j > BarsAfter && C[j] >= R && !StrongLeft ) )
                    { R=0; break; }                   //  
                  j++;
                 }
              }
            if( R >= Point )
              {
               if( Signals )
                 {
                  j=i-BarsAfter-1;                    //  
                  R=Open[j];                          //  
                 }
               else j=i;                              //  
               if( !Ban1 )
                 {   //         
                  if( k==0 ) Buffer1[j]=R; else Buffer3[j]=R;
                  if( !Repeat ) { Ban1=true; Ban2=false; }
                 }
              }
            R=0;
            j=0;
            while ( j < dim ) { C[j]=Low[j+i-BarsAfter]; j++; }
            if( C[BarsAfter+1] > C[BarsAfter] && C[BarsAfter] <= C[BarsAfter-1] )
              {
               R=C[BarsAfter];                        //  
               j=1;
               while ( j < dim )
                 {
                  if( ( j < BarsAfter && C[j-1] < C[j] && StrongRight )
                   || ( j < BarsAfter && C[j-1] < R && !StrongRight )
                   || ( j > BarsAfter && C[j] <= C[j-1] && StrongLeft )
                   || ( j > BarsAfter && C[j] <= R && !StrongLeft ) )
                    { R=0; break; }                   //  
                  j++;
                 }
              }
            if( R >= Point )
              {
               if( Signals )
                 {
                  j=i-BarsAfter-1;                    //  
                  R=Open[j];                          //  
                 }
               else j=i;                              //  
               if( !Ban2 )
                 {   //         
                  if( k==0 ) Buffer2[j]=R; else Buffer4[j]=R;
                  if( !Repeat ) { Ban1=false; Ban2=true; }
                 }
              }
           }
         i--;
        }
      if( !NotFirstStart ) NotFirstStart=true;
      if( k==0 )
        {
         NotFirstStartHF=NotFirstStart;
         Ban1HF=Ban1;
         Ban2HF=Ban2;
        }
      else
        {
         NotFirstStartLF=NotFirstStart;
         Ban1LF=Ban1;
         Ban2LF=Ban2;
        }
      k++;
     }
//----
   WindowRedraw();                                 //  .
   return(0);
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
bool NewBar() 
  {
//----
   static datetime NewTime;                     //   
   bool NewBar=false;                           //   
   if( NewTime!=Time[0] )
     {
      NewTime=Time[0];                          //   
      NewBar=true;                              //   
     }
//----
   return(NewBar);
  }
//+------------------------------------------------------------------+